CREATE PROCEDURE getFilteredProducts(@minStockLevel AS INT)
AS
BEGIN

SELECT TOP 10 *
  FROM Production.Product
  WHERE SafetyStockLevel >= @minStockLevel;
  
END



EXECUTE getFilteredProducts 800;



ALTER PROCEDURE getFilteredProducts(@minStockLevel AS INT)
AS
BEGIN

SELECT TOP 10 Name, Color, SafetyStockLevel
  FROM Production.Product
  WHERE SafetyStockLevel >= @minStockLevel
  ORDER BY SafetyStockLevel;
  
END



EXECUTE getFilteredProducts 800;



ALTER PROCEDURE getFilteredProducts(
  @minStockLevel AS INT,
  @maxStockLevel AS INT
)
AS
BEGIN

SELECT TOP 10 Name, Color, SafetyStockLevel
  FROM Production.Product
  WHERE SafetyStockLevel >= @minStockLevel AND SafetyStockLevel <= @maxStockLevel;
  
END



EXEC getFilteredProducts 500, 800;

EXEC getFilteredProducts
  @maxStockLevel = 800,
  @minStockLevel = 500;



ALTER PROCEDURE getFilteredProducts(
  @minStockLevel AS INT = 0,
  @maxStockLevel AS INT = NULL,
  @color AS VARCHAR(20)
)
AS
BEGIN

SELECT TOP 10 Name, Color, SafetyStockLevel
  FROM Production.Product
  WHERE SafetyStockLevel >= @minStockLevel 
    AND (@maxStockLevel IS NULL OR SafetyStockLevel <= @maxStockLevel) 
    AND Color LIKE '%'+@color+'%'
  ORDER BY SafetyStockLevel DESC;
  
END



EXEC getFilteredProducts 
  @maxStockLevel = 800,
  @color = 'Silver';
  
  
  
DECLARE @reorderPoint INT, @productName VARCHAR(20);
SET @reorderPoint = 750;
SELECT TOP 10 Name, Color, ReorderPoint
FROM Production.Product
WHERE ReorderPoint = @reorderPoint;



DECLARE @productCount INT;
SET @productCount = (
  SELECT COUNT(*) FROM Production.Product
);
PRINT 'Product count: ' + CAST(@productCount AS VARCHAR(20));



DECLARE @color VARCHAR(20), @safetyStockLevel INT;

SELECT
  @color = Color,
  @safetyStockLevel = SafetyStockLevel
FROM Production.Product
WHERE ProductID = 317;

SELECT @color AS boja, @safetyStockLevel AS lvl;



CREATE PROCEDURE getProductsWithVars(@color VARCHAR(20))
AS
BEGIN

DECLARE @productList VARCHAR(MAX);
SET @productList = '';

SELECT
  @productList = @productList + Name + CHAR(10)
FROM Production.Product
WHERE Color LIKE '%'+@color+'%';

PRINT @productList;
  
END;



EXECUTE getProductsWithVars 'Black';



CREATE PROCEDURE countProducts(
  @searchString VARCHAR(10),
  @product_count INT OUTPUT
)
AS
BEGIN

SELECT * FROM Production.Product
  WHERE ProductNumber LIKE '%'+@searchString+'%';
SET @product_count = @@ROWCOUNT;
  
END



DECLARE @productCount INT;

EXEC countProducts
  @searchString = 'CA',
  @product_count = @productCount OUTPUT;

SELECT @productCount AS BrojProizvoda;



