SELECT ProductID, Name, Color, SafetyStockLevel, ReorderPoint
FROM Production.Product
WHERE SafetyStockLevel > 500 AND SafetyStockLevel < 1000;

SELECT TOP 20 ProductID, Name, Color, SafetyStockLevel, ReorderPoint
FROM Production.Product
WHERE NOT (Color IS NULL)
ORDER BY Name, Color;

SELECT Color, COUNT(*) AS Cnt
FROM Production.Product
WHERE NOT (Color IS NULL)
GROUP BY Color
HAVING COUNT(*) > 10
ORDER BY Cnt DESC;

SELECT ProductID, Name, Color, SafetyStockLevel, ReorderPoint
FROM Production.Product
WHERE LOWER(Color) IN ('black', 'red');

SELECT DISTINCT Color
FROM Production.Product
WHERE LOWER(Color) LIKE '%e%';

SELECT ProductID, Name, Color, SafetyStockLevel, ReorderPoint
FROM Production.Product
WHERE NOT (Color IS NULL)
ORDER BY LEN(Color);

SELECT TOP 10 p.Name AS ProductName, s.Name AS SubcategoryName, c.Name AS CategoryName
FROM Production.Product p INNER JOIN Production.ProductSubcategory s
  ON p.ProductSubcategoryID = s.ProductSubcategoryID INNER JOIN Production.ProductCategory c
  ON s.ProductCategoryID = c.ProductCategoryID;
  
SELECT p.Name
FROM Production.Product p, Production.ProductSubcategory s, Production.ProductCategory c
WHERE p.ProductSubcategoryID = s.ProductSubcategoryID AND s.ProductCategoryID = c.ProductCategoryID AND c.Name IN (
  SELECT c.Name AS Name
  FROM Production.Product p, Production.ProductSubcategory s, Production.ProductCategory c
  WHERE p.ProductSubcategoryID = s.ProductSubcategoryID AND s.ProductCategoryID = c.ProductCategoryID
  GROUP BY c.Name
  HAVING COUNT(*) > 50
);


